## Script (Python) "search_pins"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: readOnlinePaymentsFromLog.py 1666 2007-03-31 12:18:13Z joachim $
"""
list Students for ClearanceOfficers
"""

request = context.REQUEST
session = request.SESSION
response = request.RESPONSE
setheader = request.RESPONSE.setHeader

def rwrite(s):
    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
    response.write('%s<br>\r\n' % s)

wftool = context.portal_workflow
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
roles = member.getRolesInContext(context)
retcat = context.returning_import
rcat = context.results_import
scat = context.students_catalog
from Products.AdvancedQuery import Eq, Between, Le,In
aq_students = context.students_catalog.evalAdvancedQuery
students_folder = context.portal_url.getPortalObject().campus.students
tas = context.waeup_tool.getCallbacksFromLog('epaymentsuccessful_z2log2')
for ta in tas:
    student_id = ta['student_id']
    payment_id = ta['payment_id']
    qs_dict = ta['qs_dict']
    rwrite(qs_dict)
    if not students_folder.hasObject(student_id):
        rwrite("no student %s" % student_id)
        continue
    student_obj = getattr(students_folder,student_id)
    if not student_obj.hasObject('payments'):
        rwrite("no payments for student %s" % student_id)
        continue
    payments = getattr(student_obj,'payments')
    if not payments.hasObject(payment_id):
        rwrite("no payment %s for student %s" % (payment_id,student_id))
        continue
    payment_obj = getattr(payments,payment_id)
    review_state = wftool.getInfoFor(student_obj,'review_state',None)
    #from pdb import set_trace
    if review_state == 'schoolfee_paid':
        rwrite("student %s has already state %s" % (student_id,review_state))
        continue
    review_state = wftool.getInfoFor(payment_obj,'review_state',None)
    #from pdb import set_trace
    if review_state != 'open':
        rwrite("payment %s for student %s has state %s" % (payment_id,student_id,review_state))
        continue
    resp_codes = (("x_RespDesc","resp_desc"),
      ("x_RespPayRef","resp_pay_reference"),
      ("x_RespCode","resp_code"),
      ("x_CardNum","resp_card_num"),
      ("x_ApprAmt","resp_approved_amount"),
      )
    pd = {}
    for rc,pdk in resp_codes:
        pd[pdk] = request.get(rc)
    rwrite(pd)
    #payment_obj.getContent().edit(mapping=pd)
    continue
